package org.specs2.matcher

object ExtraOptionMatchers {
  def beSomeMatching[T](someValueMatcher: =>Matcher[T]) = new Matcher[Option[T]] {
    def apply[S <: Option[T]](value: Expectable[S]) = value.value match {
      case Some(x) => matchSome(value)
      case None => MatchFailure(
        value.description + " is Some",
        value.description + " is not Some",
        value)
    }

    def matchSome[S <: Option[T]](expectable: Expectable[S]): MatchResult[S] = {
      val value = expectable.value.get
      val matchResult = someValueMatcher(Expectable(value))
      result(matchResult, expectable)
    }
  }
}